<?
/***Copyright and coded by Dakusan, please do not steal code, but you may study and learn from it... Free to use and redistribute - See http://www.castledragmire.com/Copyright for more information. ***/
/***Dakusan's Directory Manager v1.0 - http://www.castledragmire.com/Projects/Other_Web_Scripts ***/
//User options - The only option you should need to movidy is the very first one (RootDirectory)
	//Directory structures and script file names
	$RootDirectory='/home/USERDIRECTORY/public_html'; //THIS MUST BE MODIFIED
	$MyFileName='index.php';
	$PassFileName='.htpasswd'; //Can be put in another directory - if path is not relative, it must start with a "/"
	//Allowable files and types
	$DoNotShowList=Array('.', '..', $MyFileName, $PassFileName, '.htaccess');
	$DisallowedExtensions=Array('php', 'php3', 'cgi', 'pl'); //Cannot upload or rename to these extensions
	$DissalowedExtensionsAppend='.txt'; //Disallowed extensions have the following appended to them
	//User permissions - Set options to either true or false
	$AllowFileList=true;
	$AllowDeleting=true;
	$AllowRenaming=true;
	$AllowUploading=true;
	$AllowUserEdit=false; //Edit other users
	$AllowPasswordEdit=true; //Edit own password
	$IgnoreDisallowedExtensions=false;
	//[Admin] Permission state modifiers - Comment out line or set to FALSE to ignore option
	$AdminUsers=Array('admin'); //When logged in, these user(s) have all "AdminPermissions" set to true
	$PermissionsIfNoPassFileFound=Array('FileList','Deleting','Renaming','Uploading','UserEdit','PasswordEdit'); //Permissions set to true when no password file is found - Default is all permissions but IgnoreDisallowedExtensions
	$AdminPermissions=Array('FileList','Deleting','Renaming','Uploading','UserEdit','PasswordEdit','IgnoreDisallowedExtensions'); //Permissions set to true when in admin mode - Default is all permissions
	//Default sorting options
	$SortBy='Name'; //Default SortBy, options include "Name", "Size", and "ModTime" (Last Modified Time)
	$SortDesc=false; //Sort Ascending (false) or descending (true)
	//Other options
	$PasswordHashFunction='crypt'; //Usually "crypt", Windows' IIS might need "md5"
//END of User Options

//Output informational messages
function ReturnMessage($P) //Function parameters are in STATIC_MESSAGE, VARIABLE, STATIC_MESSAGE2, VARIABLE2, ... format
{
	print '<font color=red>';
	foreach(func_get_args() as $i => $Arg)
		if($i&1) //variable
			print '"<b>'.htmlentities(substr($Arg, 0, 1)=='!' ? substr($Arg, 1) : $_REQUEST[$Arg]).'</b>" '; //If the variable starts with an exclamation mark, it is an actual value, otherwise, it is a variable name found in $_REQUEST
		else
			print "$Arg ";
	print '</font><br>';
}

//Confirm valid files names
function IsFileNameOK(&$FN, $IsModifying) //Filename we are checking (updated inside the function if needed), and checking if file exists if modifying, or does not exist if creating (IsModifying=false)
{
	if(!isset($FN)) //Confirm variable is even set
	{
		$FN='NOT SPECIFIED';
		return FALSE;
	}

	//Check against DoNotShowList, for invalid characters ('/')
	global $DoNotShowList;
	if(in_array($FN, $DoNotShowList) || strpos($FN, '/'))
	{
		if(in_array($FN, $DoNotShowList))
			ReturnMessage('This specific filename is restricted.');
		if(strpos($FN, '/'))
			ReturnMessage('', '!/', 'character is not allowed in filenames.');
		return FALSE;
	}
	
	//Modify name according to allowed extensions
	global $IgnoreDisallowedExtensions, $DisallowedExtensions, $DissalowedExtensionsAppend;
	if(!$IgnoreDisallowedExtensions)
	{
		$MyExt=strrchr($FN, '.'); //Get the extension from the last dot
		$MyExt=($MyExt==FALSE || $MyExt=='.' ? '' : substr($MyExt, 1)); //Remove the dot - Set to blank if no extension is found
		if(in_array($MyExt, $DisallowedExtensions)) //If an invalid extension, append ending
		{
			ReturnMessage('Non allowed file extension ', "!$MyExt", 'detected. Changing file name from', "!$FN", 'to', "!$FN$DissalowedExtensionsAppend", '.');
			$FN.=$DissalowedExtensionsAppend; //Update filename
		}
	}
	
	if($IsModifying) //If deleting/renaming from, return if file currently exists
		return file_exists($FN);

	//If creating/renaming to, update name accordingly until name does not conflict
	$NewFN=$FN;
	$CurNum=0;
	while(file_exists($NewFN)) //Append .v# until a file name conflict is not found
		$NewFN="$FN.v".++$CurNum;
	if($CurNum)
		ReturnMessage('File name ', "!$FN", 'already exists. File being named as ', "!$NewFN", '.');
	$FN=$NewFN;
	return true;
}

//Create the password and access file
function UpdatePassFile(&$User, $Pass)
{
	global $PassFileName, $PasswordHashFunction;
	//Read in previous password information
	$MyUsersO=(file_exists($PassFileName) ? explode("\n",file_get_contents($PassFileName)) : Array()); //Get basic user list in format x=>"user:pass"
	$MyUsers=Array();
	foreach($MyUsersO as $U) //Get user list in format user=>"user:pass"
		$MyUsers[substr($U, 0, strpos($U,':'))]=$U;
		
	//Fix username to valid characters and non blank
	$User=preg_replace('/[^A-Za-z0-9_]/','',$User);
	$User=($User=='' ? 'Default' : $User);
	
	//Perform action
	if($Pass!='') //If password is not empty, modify user
	{
		$MyMessage=Array('User', 'UserName', isset($MyUsers[$User]) ? 'modified' : 'created');
		$MyUsers[$User]="$User:".eval("return $PasswordHashFunction(\$Pass);");
	}
	else //Otherwise, delete user
	{
		$MyMessage=Array('User', 'UserName', isset($MyUsers[$User]) ? 'deleted' : 'non existant');
		unset($MyUsers[$User]);
	}
	
	if(!count($MyUsers)) //If no more users, delete existing password files
	{
		if(file_exists('.htaccess')) unlink('.htaccess');
		if(file_exists($PassFileName)) unlink($PassFileName);
		call_user_func_array('ReturnMessage', $MyMessage);
		return;
	}
	
	if(($HTPasswd=fopen($PassFileName, 'w'))===FALSE) //Attempt to write out new password file
	{
		ReturnMessage('Password file cannot be accessed.');
		return;
	}
	fwrite($HTPasswd, implode("\n", $MyUsers));
	fclose($HTPasswd);
	call_user_func_array('ReturnMessage', $MyMessage);
	

	if(!file_exists('.htaccess')) //Write out permissions file, if it doesn't exist, to require access credentials, and deny access to itself and the password file
	{
		if(($HTAccess=fopen('.htaccess', 'w'))===FALSE) //Attempt to open for writing
		{
			ReturnMessage('Directory access file cannot be accessed.');
			return;			
		}
		
		fwrite($HTAccess, preg_replace('/^\s+/m', '', //Strip whitespace - This file makes authentication required to enter the directory, and makes the .htaccess and password (if it is in the current directory) files unviewable
			'AuthType Basic
			AuthName "Access Required"
			AuthUserFile "'.($PassFileName[0]=='/' ? $PassFileName : getcwd()."/$PassFileName").'"
			require valid-user
			<FilesMatch "^'.(strpos($PassFileName,'/')===FALSE ? "$PassFileName|" : '').'.htaccess$">
			order deny,allow
			deny from all
			</FilesMatch>'
		));
		fclose($HTAccess);
	}
}

//Human readable sizes
function HumanReadableSize($Size)
{
	$MetricSizes=Array('Bytes', 'KB', 'MB', 'GB', 'TB');
	for($SizeOn=0;$Size>=1024 && $SizeOn<count($MetricSizes)-1;$SizeOn++) //Loops until Size is < a binary thousand (1,024) or we have run out of listed Metric Sizes
		$Size/=1024;
	return preg_replace('/\\.?0+$/', '', number_format($Size, 2, '.', ',')).' '.$MetricSizes[$SizeOn]; //Forces to a maximum of 2 decimal places, adds comma at thousands place, appends metric size
}

//Confirm administrator and password file status
if(!file_exists($PassFileName) && isset($PermissionsIfNoPassFileFound) && is_array($PermissionsIfNoPassFileFound)) //If no password file, add appropriate permissions
	foreach($PermissionsIfNoPassFileFound as $Perm)
		${"Allow$Perm"}=true;
if(isset($_SERVER['PHP_AUTH_USER']) && isset($AdminUsers) && is_array($AdminUsers) && in_array($_SERVER['PHP_AUTH_USER'], $AdminUsers) && isset($AdminPermissions) && is_array($AdminPermissions)) //If an admin, add appropriate permissions
	foreach($AdminPermissions as $Perm)
		${"Allow$Perm"}=true;

//Logout
if(isset($_REQUEST['MyAction']) && $_REQUEST['MyAction']=='LogOut')
{
	header('WWW-Authenticate: Basic realm="Access Required"');
	header("HTTP/1.0 401 Unauthorized");
	exit;
}

//Sorting options
$SortBy=(isset($_REQUEST['SortBy']) ? $_REQUEST['SortBy'] : (isset($SortBy) ? $SortBy : '')); //If new SortBy is requested, use it
$AllowedSortBy=Array('Name','Size','ModTime');
$SortBy=(in_array($SortBy, $AllowedSortBy) ? $SortBy : 'Name'); //Confirm SortBy is valid, and if not, use 'Name' as default
$SortDesc=(isset($_REQUEST['SortDesc']) ? ($_REQUEST['SortDesc']=='true') : (isset($SortBy) ? $SortDesc : false)); //If new SortDesc is requested, use it, otherwise, use false

//Header
header('Content-Type: text/html; charset=utf-8'); ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title>File Manager</title>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=utf-8">
	<META HTTP-EQUIV="CONTENT-LANGUAGE" CONTENT="en-US">
</head>
<body>
<?
//Perform actions
if(isset($_REQUEST['MyAction']))
{
	switch($_REQUEST['MyAction'])
	{
		case 'Delete':
			if(!$AllowDeleting) //Confirm permission
				ReturnMessage('Not allowed to delete files.');
			else if(!IsFileNameOK($_REQUEST['FileName'], true)) //Confirm valid file name
				ReturnMessage('Cannot delete', 'FileName', '; invalid file name.');
			else if(!unlink($_REQUEST['FileName'])) //Try to delete
				ReturnMessage('Cannot delete', 'FileName', '; file deletion error.');
			else //Successfully deleted
				ReturnMessage('File', 'FileName', 'successfully deleted.');
			break;
		case 'Rename':
			if(!$AllowRenaming) //Confirm permission
				ReturnMessage('Not allowed to rename files.');
			else if(!IsFileNameOK($_REQUEST['FileName'], true)) //Confirm valid file name
				ReturnMessage('Cannot rename', 'FileName', '; invalid file name.');
			else if(!IsFileNameOK($_REQUEST['RenameAs'], false)) //Confirm valid rename file name
				ReturnMessage('Cannot rename', 'FileName', 'as', 'RenameAs', '; invalid new file name.');
			else if(!rename($_REQUEST['FileName'], $_REQUEST['RenameAs'])) //Try to rename
				ReturnMessage('Cannot rename', 'FileName', 'as', 'RenameAs', '; error during rename attempt.');
			else //Successfull renamed
				ReturnMessage('File', 'FileName', 'successfully renamed as', 'RenameAs', '.');
			break;
		case 'Upload':
			if(!$AllowUploading) //Confirm permission
				ReturnMessage('Not allowed to upload files.');
			else if(!isset($_FILES['UploadFile'])) //Confirm file was uploaded
				ReturnMessage('No file specified.');
			else if($_FILES['UploadFile']['error']!=UPLOAD_ERR_OK) //Make sure there were no upload errors
			{
				$UploadErrors=Array(UPLOAD_ERR_INI_SIZE=>'The uploaded file exceeds the upload_max_filesize ('.ini_get('upload_max_filesize').').', UPLOAD_ERR_FORM_SIZE=>'The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.', UPLOAD_ERR_PARTIAL=>'The uploaded file was only partially uploaded.', UPLOAD_ERR_NO_FILE=>'No file was uploaded.', UPLOAD_ERR_NO_TMP_DIR=>'Missing a temporary folder.', UPLOAD_ERR_CANT_WRITE=>'Failed to write file to disk.', UPLOAD_ERR_EXTENSION=>'File upload stopped by extension.');
				if(isset($UploadErrors[$_FILES['UploadFile']['error']]))
					ReturnMessage($UploadErrors[$_FILES['UploadFile']['error']]);
				else
					ReturnMessage('Unknown file upload error.');
			}
			else if($_FILES['UploadFile']['size']<0) //Check for negative file size
				ReturnMessage('Unknown file upload error.');
			else if(!IsFileNameOK($_FILES['UploadFile']['name'], false)) //Confirm valid file name
				ReturnMessage('Cannot create', '!'.$_FILES['UploadFile']['name'], '; invalid file name.');
			else if(move_uploaded_file($_FILES['UploadFile']['tmp_name'], $_FILES['UploadFile']['name'])===FALSE) //Move uploaded file into local folder
				ReturnMessage('Attempt to move uploaded file into current folder failed.');
			else //Successfull renamed
				ReturnMessage('File', "!".$_FILES['UploadFile']['name'], 'successfully uploaded.');
			break;
		case 'EditUser':
			if(!$AllowUserEdit) //Confirm permission
				ReturnMessage('Not allowed to edit other user information.');
			else if(!isset($_REQUEST['UserName']) || !isset($_REQUEST['UserPassword'])) //Check for passed information
				ReturnMessage('User update information not supplied.');
			else //Attempt update
				UpdatePassFile($_REQUEST['UserName'], $_REQUEST['UserPassword']);
			break;
		case 'EditPassword':
			if(!$AllowPasswordEdit) //Confirm permission
				ReturnMessage('Not allowed to edit password.');
			else if(!isset($_SERVER['PHP_AUTH_USER'])) //Check for passed apache username
				ReturnMessage('Username could not be retreived.');
			else if(!isset($_REQUEST['UserPassword'])) //Check for passed information
				ReturnMessage('User update information not supplied.');
			else if($_REQUEST['UserPassword']=='') //Check for passed information
				ReturnMessage('Cannot set a blank password.');
			else //Attempt update
			{
				$_REQUEST['UserName']=$_SERVER['PHP_AUTH_USER'];
				UpdatePassFile($_REQUEST['UserName'], $_REQUEST['UserPassword']);
			}
			break;
		default: //An unknown action was passed
			ReturnMessage('Invalid action', 'MyAction', '.');
	}
}

//Get the current directory's information
$MyDir=str_replace('\\', '/', substr(getcwd(), strlen($RootDirectory))); //Path from root - Replace "\" with "/"
$MyURL=str_replace('%2F', '/', urlencode($MyDir)); //URL encoded path

//Output logged in information
if(isset($_SERVER['PHP_AUTH_USER']))
	print "Logged in as: $_SERVER[PHP_AUTH_USER] [<a href=\"$MyFileName?MyAction=LogOut\" onclick=\"alert('For FireFox, just cancel out of next password dialog to clear credentials. For IE, you must enter invalid credentials once before canceling out of the next dialog.')\">Log out</a>]<br>";

//Output folder information
print 'Index for: <a href="'.$MyURL.'">'.htmlentities($MyDir).'</a><br><br>';

//Loop through all files in directory
if($AllowFileList)
{
	//Gather file list
	$DirHan=opendir('./');
	$MyFiles=Array();
	while(($FileName=readdir($DirHan))!==FALSE)
		if(!in_array($FileName, $DoNotShowList)) //Bypass files in our do not show list
			$MyFiles[]=Array('Name'=>$FileName, 'Size'=>filesize($FileName), 'ModTime'=>filemtime($FileName));
	closedir($DirHan);

	//Sort files
	function MySortFunc($a, $b) { global $SortBy, $SortDesc; return ($a[$SortBy] >= $b[$SortBy]) ^ $SortDesc; }
	usort($MyFiles, 'MySortFunc');
	
	//Output contents in a table
	if(count($MyFiles)) //If files are found
	{
		//Table head
		print '<table cellspacing=0 cellpadding=5><tr>';
		$HeadCols=Array('Name'=>'Name', 'Size'=>'Size', 'ModTime'=>'Last Modified');
		foreach($HeadCols as $SortName => $ColName)
			print "<th><a href=\"$MyFileName?SortBy=$SortName&amp;SortDesc=".($SortName==$SortBy && $SortDesc==false ? 'true' : 'false')."\">$ColName</a>".($SortName==$SortBy ? ($SortDesc ? ' -' : ' +') : '')."</th>";
		print '</tr>';

		//Output file list
		foreach($MyFiles as $File)
			print '<tr><td><a href="'.$MyURL.'/'.urlencode($File['Name']).'">'.htmlentities($File['Name']).'</a></td><td>'.HumanReadableSize($File['Size']).'</td><td>'.date('m/d/y g:ia', $File['ModTime']).'</td><td>'.($AllowDeleting ? '<a href="#" onclick="return Delete(this);">delete</a> ' : '').($AllowRenaming ? '<a href="#" onclick="return Rename(this);">rename</a>' : '').'</td></tr>';
			
		//End of table and file count
		print '</table>'.count($MyFiles).' file(s) found.<br><br>';
	}
	else //No files found
		print  '<font color=red>No files found</font><br><br>';
}

//Form sort options
$FormSortOptions='<input type=hidden name=SortBy value="'.$SortBy.'"><input type=hidden name=SortDesc value="'.($SortDesc ? 'true' : 'false').'">';

//Upload a file section
if($AllowUploading)
	print '<form action=index.php method=post enctype=multipart/form-data><input type=hidden name=MyAction value=Upload>'.$FormSortOptions.'Upload file: <input type=file name=UploadFile><input type=submit value="Upload File"></form><br>';
	
print '<hr><br>';

//Edit users section
if($AllowUserEdit)
{
	//Show list of current users
	$CurrentUsers=(file_exists($PassFileName) ? explode("\n", preg_replace('/:.*$/m', '', file_get_contents($PassFileName))) : Array());
	print 'Current Users: '.implode(', ', $CurrentUsers).'<br>';
	print '<form action=index.php method=get><input type=hidden name=MyAction value=EditUser>'.$FormSortOptions.'Edit/add user: <input type=text name=UserName> with password <input type=password name=UserPassword> [A blank password will delete a user] <input type=submit value="Edit/Add User"></form><br>';
}

if(isset($_SERVER['PHP_AUTH_USER']) && $AllowPasswordEdit) //Edit user's password if sent through apache
	print '<form action=index.php method=get><input type=hidden name=MyAction value=EditPassword>'.$FormSortOptions.'Edit your password: <input type=password name=UserPassword> <input type=submit value="Edit Password"></form><br>';

//Footer
if($AllowDeleting || $AllowRenaming) { //Only include deleting/renaming functions if permissions are given ?>
<script type="text/javascript">
	function GetFileName(O) { return O.parentNode.parentNode.cells[0].firstChild.innerHTML; } //Returns the filename (from the link from the first cell in the row) when delete/rename is clicked
	function ReDirectPage(P) //Redirect to self with new parameters (Listed in P)
	{
		var A=['SortBy=<?=$SortBy?>', 'SortDesc=<?=($SortDesc ? 'true' : 'false')?>'];
		for(n in P) //Turn parameter object from Name:Value into array x:"Name=Value"
			A.push(escape(n)+'='+escape(P[n]));
		document.location.href='<?="$MyURL/$MyFileName"?>?'+A.join('&'); //Do the redirect with joined parameters
	}
<? if($AllowDeleting) { ?>
	function Delete(O) { ReDirectPage({MyAction:'Delete',FileName:GetFileName(O)}); return false;}
<? } if($AllowRenaming) { ?>
	function Rename(O)
	{
		var MyFile=GetFileName(O), NewFileName=prompt("New name for '"+MyFile+"'?", '');
		if(NewFileName!=false && NewFileName!=null && NewFileName!="") //Confirm file name was passed
			ReDirectPage({MyAction:'Rename',FileName:MyFile, RenameAs:NewFileName});
		return false;
	}
<? } ?>
</script>
<? } ?>
</body></html>